/*****************************/
/* kChat v1.6a		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.net.*;
import java.io.*;

public class kChatServer 
{
/*************************************************************************************/
	public static void main(String[] args) throws IOException
	{
		ServerSocket serverS = null;
		int nrPortu = 1979; 
		boolean listening = true;
		
		if ((args.length>0) && (!args[0].equals("")))
		    configFileParse(args[0]); 
		    else 
		    configFileParse("./kChat.conf"); 
		    
		
		try 
{
		    serverS = new ServerSocket(nrPortu);
		    System.out.println("\nOK. listen at port " + nrPortu);
		}
 catch (IOException e) 
{
		    System.out.println("Listen at " + nrPortu + " impossible, i don't know why ! " + e);
		    System.exit(1);
		}

		kChatPing ping = new kChatPing();
		ping.start();

		while (listening)
		    new kChatServerThread(serverS.accept()).start();
		    
		ping.stop();
		serverS.close();
	}

/*************************************************************************************/
	private static void configFileParse(String filename) {
	    try {
	    FileReader fr = new FileReader(filename);
	    BufferedReader frb = new BufferedReader(fr);
	    
	    String line = new String("");
	    while (line!=null) {
		line = frb.readLine();
		if ((line!=null)&&(!line.startsWith("#"))&&(!line.equals(""))) {
		    String command = line.substring(0,line.indexOf("=",0));
		    String value   = line.substring(line.indexOf("=",0)+1);
		    if (command.equals("logfile")) kChatSystem.logfile=value;
		    if (command.equals("log")) kChatSystem.log=value;
		    if (command.equals("rnicks")) kChatSystem.rnicksFilename=value;
		    if (command.equals("moderpass")) kChatSystem.moderpass=value;
		    // System.out.println(command + " = " + value);
		    }
		}
	    } catch (IOException e) { e.printStackTrace(); }
	}

		
}
